//Tsunami.cs
//Made by Heedicalking.

//audio

datablock AudioProfile(TSUShotSound)
{
   filename    = "./TSUshot.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(TsunamiexplosionParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = 1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 700;
   lifetimeVarianceMS   = 400;
   textureName          = "base/data/particles/cloud";
   spinSpeed      = 10.0;
   spinRandomMin      = -50.0;
   spinRandomMax      = 50.0;
   colors[0]     = "0 0.1 1 0.3";
   colors[1]     = "0 0 1 0";
   sizes[0]      = 3.0;
   sizes[1]      = 2.75;

   useInvAlpha = true;
};
datablock ParticleEmitterData(TsunamiexplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TsunamiexplosionParticle";
};

datablock ParticleData(TsunamiexplosionRingParticle)
{
   dragCoefficient      = 4;
   gravityCoefficient   = 0;
   inheritedVelFactor   = -0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 50;
   lifetimeVarianceMS   = 35;
   textureName          = "base/data/particles/cloud";
   spinSpeed      = 200;
   spinRandomMin      = -100;
   spinRandomMax      = 100;
   colors[0]     = "0 0 1 0.9";
   colors[1]     = "0 0.1 1 0.0";
   sizes[0]      = 3;
   sizes[1]      = 2;

   useInvAlpha = false;
};
datablock ParticleEmitterData(TsunamiexplosionRingEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 0.3;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "TsunamiexplosionRingParticle";
};

datablock ExplosionData(Tsunamiexplosion)
{
   //explosionShape = "";

   lifeTimeMS = 150;

   particleEmitter = TsunamiexplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = TsunamiexplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   lightStartRadius = 1;
   lightEndRadius = 2;
   lightStartColor = "1 0.75 0.25";
   lightEndColor = "0 0 0";

   radiusDamage = 160;
   damageRadius = 11;
};


AddDamageType("Tsunami",'<bitmap:add-ons/Weapon_Tsunami/CI_Tsunami> %1','%2 <bitmap:add-ons/Weapon_Tsunami/CI_Tsunami> %1',0.5,1);

datablock ProjectileData(Tsunamiprojectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 5;
   directDamageType    = $DamageType::Tsunami;
   radiusDamageType    = $DamageType::Tsunami;

   brickExplosionRadius = 10;
   brickExplosionImpact = false;
   brickExplosionForce  = 50;
   brickExplosionMaxVolume = 250; 
   brickExplosionMaxVolumeFloating = 400;

   impactImpulse   = 5;
   verticalImpulse = 15;
   explosion       = Tsunamiexplosion;
   particleEmitter     = TsunamiexplosionEmitter;

   muzzleVelocity   = 140;
   velInheritFactor = 1;

   armingDelay      = 0;
   lifetime         = 4000;
   fadeDelay        = 3500;

   bounceElasticity = 0.01;
   bounceFriction   = 0.99;

   isBallistic      = false;
   gravityMod       = 0;

   hasLight    = false;

   uiName = "Tsunami Bullet";
};

datablock ItemData(Tsunamiitem)
{
   category = "Weapon";
   className = "Weapon";

   shapeFile = "./Tsunami.dts";
   rotate = false;
   mass = 2;
   density = 1;
   elasticity = 0.1;
   friction = 0.9;
   emap = true;

   uiName = "Tsunami";
   iconName = "./icon_Tsunami";
   doColorShift = false;
   colorShiftColor = "0.25 0.25 0.25 1";

   image = Tsunamiimage;
   canDrop = true;
};

datablock ShapeBaseImageData(Tsunamiimage)
{
   shapeFile = "./Tsunami.dts";
   emap      = true;

   mountPoint = 0;
   offset     = "0 0 0";
   eyeOffset  = 0;
   rotation   = "0 0 0";

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = Tsunamiitem;
   ammo = " ";

   projectile     = Tsunamiprojectile;
   projectileType = Projectile;
   minShotTime = 4000;


   melee = false;
   armReady = true;

   doColorShift = false;
   colorShiftColor = Tsunamiitem.colorShiftColor;

   stateName[0]                    = "Activate";
   stateTransitionOnTriggerDown[0] = "Fire";
   stateSequence[0]                = "Activate";
   stateTimeoutValue[0]        = 4.0;
   stateTransitionOnTimeout[0] = "Ready";

   stateName[1]                    = "Ready";
   stateTransitionOnTriggerDown[1] = "Fire";
   stateAllowImageChange[1]        = true;

   stateName[2]                = "Fire";
   stateTransitionOnTimeout[2] = "Smoke";
   stateTimeoutValue[2]        = 4.0;
   stateFire[2]                = true;
   stateAllowImageChange[2]    = false;
   stateSequence[2]            = "Fire";
   stateScript[2]              = "onFire";
   stateWaitForTimeout[2]      = true;
   stateSound[2]               = TSUShotSound;
   stateEjectShell[2]          = false;

   stateName[3]                = "Smoke";
   stateTimeoutValue[3]        = 0.04;
   stateTransitionOnTimeout[3] = "Reload";

   stateName[4]                    = "Reload";
   stateSequence[4]                = "Reload";
   stateTransitionOnTriggerUp[4]   = "Ready";
   stateTransitionOnTriggerDown[4] = "Fire";
   stateSequence[4]                = "Ready";
};
